/*
 * Copyright 1997-2015 Optimatika (www.optimatika.se)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
package org.ojalgo.constant;

public abstract class PrimitivePrefix {

    public static final double YOCTO = BigPrefix.YOCTO.doubleValue();
    public static final double ZEPTO = BigPrefix.ZEPTO.doubleValue();
    public static final double ATTO = BigPrefix.ATTO.doubleValue();
    public static final double FEMTO = BigPrefix.FEMTO.doubleValue();
    public static final double PICO = BigPrefix.PICO.doubleValue();
    public static final double NANO = BigPrefix.NANO.doubleValue();
    public static final double MICRO = BigPrefix.MICRO.doubleValue();
    public static final double MILLI = BigPrefix.MILLI.doubleValue();
    public static final double CENTI = BigPrefix.CENTI.doubleValue();
    public static final double DECI = BigPrefix.DECI.doubleValue();
    public static final double DEKA = BigPrefix.DEKA.doubleValue();
    public static final double HECTO = BigPrefix.HECTO.doubleValue();
    public static final double KILO = BigPrefix.KILO.doubleValue();
    public static final double MEGA = BigPrefix.MEGA.doubleValue();
    public static final double GIGA = BigPrefix.GIGA.doubleValue();
    public static final double TERA = BigPrefix.TERA.doubleValue();
    public static final double PETA = BigPrefix.PETA.doubleValue();
    public static final double EXA = BigPrefix.EXA.doubleValue();
    public static final double ZETTA = BigPrefix.ZETTA.doubleValue();
    public static final double YOTTA = BigPrefix.YOTTA.doubleValue();

    private PrimitivePrefix() {
        super();
    }

}
